"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DocumentsGraphqlTable = void 0;
var _react = _interopRequireWildcard(require("react"));
var _terminusdbReactTable = require("@terminusdb/terminusdb-react-table");
var _useTDBGraphqlQuery2 = require("../hook/useTDBGraphqlQuery");
var _reactBootstrap = require("react-bootstrap");
var _GraphqlQueryViewer = require("./GraphqlQueryViewer");
var _graphqlFormatter = require("graphql-formatter");
var _Accordion = _interopRequireDefault(require("react-bootstrap/Accordion"));
var _ri = require("react-icons/ri");
var _hi = require("react-icons/hi");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
//to be review
var DocumentsGraphqlTable = function DocumentsGraphqlTable(_ref) {
  var gqlQuery = _ref.gqlQuery,
    apolloClient = _ref.apolloClient,
    tableConfig = _ref.tableConfig,
    type = _ref.type,
    onRowClick = _ref.onRowClick,
    onViewButtonClick = _ref.onViewButtonClick,
    onEditButtonClick = _ref.onEditButtonClick,
    onDeleteButtonClick = _ref.onDeleteButtonClick,
    _ref$showGraphqlTab = _ref.showGraphqlTab,
    showGraphqlTab = _ref$showGraphqlTab === void 0 ? true : _ref$showGraphqlTab;
  if (!tableConfig) return '';
  var query = gqlQuery; //gql`${querystr}`
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    advSearchFields = _useState2[0],
    setAdvFields = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    queryToDisplay = _useState4[0],
    setQueryTodisplay = _useState4[1];
  if (!query) return "";
  var tablesColumnsConfig = tableConfig.tablesColumnsConfig[type] || [];
  var _useTDBGraphqlQuery = (0, _useTDBGraphqlQuery2.useTDBGraphqlQuery)(apolloClient, query, type, {
      limit: 10,
      start: 0,
      tableConfigObj: tablesColumnsConfig
    }),
    setError = _useTDBGraphqlQuery.setError,
    callGraphqlServer = _useTDBGraphqlQuery.callGraphqlServer,
    error = _useTDBGraphqlQuery.error,
    changeOrders = _useTDBGraphqlQuery.changeOrders,
    changeLimits = _useTDBGraphqlQuery.changeLimits,
    changeFilters = _useTDBGraphqlQuery.changeFilters,
    setAdvancedFilters = _useTDBGraphqlQuery.setAdvancedFilters,
    orderBy = _useTDBGraphqlQuery.orderBy,
    filterBy = _useTDBGraphqlQuery.filterBy,
    queryFilters = _useTDBGraphqlQuery.queryFilters,
    queryOrders = _useTDBGraphqlQuery.queryOrders,
    limit = _useTDBGraphqlQuery.limit,
    start = _useTDBGraphqlQuery.start,
    loading = _useTDBGraphqlQuery.loading,
    rowCount = _useTDBGraphqlQuery.rowCount,
    data = _useTDBGraphqlQuery.documentResults,
    extractedData = _useTDBGraphqlQuery.extractedData,
    hiddenColumnsArr = _useTDBGraphqlQuery.hiddenColumnsArr,
    setHiddenColumns = _useTDBGraphqlQuery.setHiddenColumns;
  var extractedResults = extractedData || [];
  (0, _react.useEffect)(function () {
    if (type) {
      callGraphqlServer(10, 0, {}, false);
      var queryStr = query.loc.source.body;
      setQueryTodisplay((0, _graphqlFormatter.format)(queryStr));
      setAdvFields(tableConfig.advancedSearchObj[type]);
    }
  }, [type]);
  function onRowClickCall(row) {
    if (onRowClick) {
      var rowTmp = row && row.original ? {
        label: row.original.name,
        id: row.original.fullID
      } : {};
      onRowClick(rowTmp);
    }
  }
  var deleteAction = function deleteAction(evt, row) {
    evt.stopPropagation();
    if (onDeleteButtonClick) {
      var rowTmp = row && row.original ? {
        label: row.original.name,
        id: row.original.fullID
      } : {};
      onDeleteButtonClick(rowTmp);
    }
  };
  var viewAction = function viewAction(evt, row) {
    evt.stopPropagation();
    if (onViewButtonClick) {
      var rowTmp = row && row.original ? {
        label: row.original.name,
        id: row.original.fullID
      } : {};
      onViewButtonClick(rowTmp);
    }
  };
  var editAction = function editAction(evt, row) {
    evt.stopPropagation();
    if (onEditButtonClick) {
      var rowTmp = row && row.original ? {
        label: row.original.name,
        id: row.original.fullID
      } : {};
      onEditButtonClick(rowTmp);
    }
  };
  var getActionButtons = function getActionButtons(props) {
    var invFullId = props.cell.row; //.original['id']
    //const name = cell.row.original['name']
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
      className: "d-flex justify-content-end mr-4"
    }, onViewButtonClick && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "success",
      size: "sm",
      className: "ml-3",
      title: "view document",
      onClick: function onClick(evt) {
        return viewAction(evt, invFullId);
      }
    }, /*#__PURE__*/_react["default"].createElement(_hi.HiOutlineDocument, null)), onEditButtonClick && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "success",
      size: "sm",
      className: "ml-3",
      title: "edit document",
      onClick: function onClick(evt) {
        return editAction(evt, invFullId);
      }
    }, /*#__PURE__*/_react["default"].createElement(_ri.RiEdit2Fill, null)), onDeleteButtonClick && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Button, {
      variant: "danger",
      size: "sm",
      className: "ml-3",
      title: "delete document",
      onClick: function onClick(evt) {
        return deleteAction(evt, invFullId);
      }
    }, /*#__PURE__*/_react["default"].createElement(_ri.RiDeleteBin7Line, null))));
  };
  var actionsButttons = {
    Header: "",
    accessor: "__ACTIONS__",
    disableFilters: true,
    disableSortBy: true,
    id: "__ACTIONS__",
    renderer: getActionButtons
  };

  // to be review
  var tableConfigObj = {};
  tableConfigObj.columns = JSON.parse(JSON.stringify(tablesColumnsConfig));
  if (onDeleteButtonClick || onEditButtonClick || onViewButtonClick) {
    tableConfigObj.columns.push(actionsButttons);
  }
  if (onRowClickCall) {
    tableConfigObj.rowClick = onRowClickCall;
  }
  var errorMessage = error && _typeof(error) === "object" ? JSON.stringify(error, null, 2) : error;
  return /*#__PURE__*/_react["default"].createElement("div", null, error && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Alert, {
    onClose: function onClose() {
      return setError(false);
    },
    dismissible: true,
    className: "text-break",
    variant: "danger"
  }, "GraphQL query error ", /*#__PURE__*/_react["default"].createElement("pre", {
    className: "pre--error"
  }, errorMessage), " "), advSearchFields && /*#__PURE__*/_react["default"].createElement(_Accordion["default"], {
    className: "mb-4"
  }, /*#__PURE__*/_react["default"].createElement(_Accordion["default"].Item, {
    eventKey: "0"
  }, /*#__PURE__*/_react["default"].createElement(_Accordion["default"].Header, null, "Advanced filter"), /*#__PURE__*/_react["default"].createElement(_Accordion["default"].Body, {
    className: "p-0"
  }, /*#__PURE__*/_react["default"].createElement(_terminusdbReactTable.AdvancedSearch, {
    fields: advSearchFields,
    setFilter: setAdvancedFilters
  })))), loading && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Container, {
    className: "loading-bar-align justify-content-center"
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.ProgressBar, {
    message: "Loading ".concat(type, " ...")
  })), !loading && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Tabs, {
    defaultActiveKey: "table",
    className: "mb-3"
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Tab, {
    eventKey: "table",
    title: "Result Table"
  }, !loading && Array.isArray(extractedResults) && /*#__PURE__*/_react["default"].createElement(_terminusdbReactTable.GraphqlTable
  // dowloadConfig={{filename:"test.csv",headers:["Author","Commit ID"]}}
  , {
    result: extractedResults,
    freewidth: true,
    config: tableConfigObj,
    hiddenColumnsArr: hiddenColumnsArr,
    setHiddenColumns: setHiddenColumns,
    limit: limit,
    start: start,
    orderBy: orderBy,
    setFilters: changeFilters,
    setLimits: changeLimits,
    setOrder: changeOrders,
    loading: loading,
    totalRows: rowCount
  })), showGraphqlTab && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Tab, {
    eventKey: "graphql",
    title: "Graphql Query"
  }, /*#__PURE__*/_react["default"].createElement("div", null, queryToDisplay && /*#__PURE__*/_react["default"].createElement(_GraphqlQueryViewer.GraphqlQueryView, {
    filterBy: queryFilters,
    orderBy: queryOrders,
    start: start,
    limit: limit,
    queryToDisplay: queryToDisplay
  })))));
};

/*<div> 
            {error && <Alert className="text-break" variant="danger"> GraphQL query error {error} </Alert>}         
            {advSearchFields &&
                 <Accordion className="mb-4">
                    <Accordion.Item eventKey="0">
                        <Accordion.Header>Advanced filter</Accordion.Header>
                        <Accordion.Body>
                            <AdvancedSearch fields={advSearchFields} setFilter={setAdvancedFilters} />
                        </Accordion.Body>
                    </Accordion.Item>
</Accordion>}       
            {loading && <Container className="loading-bar-align justify-content-center">
                            <ProgressBar  message={`Loading ${type} ...`}/>
                        </Container>}
            {!loading && 
            <Tabs defaultActiveKey="table" className="mb-3" >
                <Tab eventKey="table" title="Result Table">hello 
                    {!loading && Array.isArray(extractedResults) && 
                     <GraphqlTable
                     // dowloadConfig={{filename:"test.csv",headers:["Author","Commit ID"]}}
                      result={extractedResults}
                      freewidth={true}
                      config ={tableConfigObj}
                    //  hiddenColumnsArr = {hiddenColumnsArr}
                   //   view={(tableConfig ? tableConfig.json() : {})}
                      limit={limit}
                      start={start}
                      orderBy={[]} 
                      setFilters = {changeFilters}
                      setLimits={changeLimits}
                     // setOrder={changeOrder}
                      loading={loading}
                      totalRows={rowCount}
                      onRefresh={function(){}}
            />}
            </Tab>
           {showGraphqlTab && <Tab eventKey="graphql" title="Graphql Query">
                <div>
                {queryToDisplay && 
                   {<GraphqlQueryView 
                     filterBy={queryFilters}
                     orderBy={queryOrderBy}
                     start={start}
                     limit={limit}
                   queryToDisplay={queryToDisplay} />}
                }
                </div>
            </Tab>}
         </Tabs>}
    </div>*/
exports.DocumentsGraphqlTable = DocumentsGraphqlTable;